﻿using System;
using System.IO;
using System.IO.Packaging;
using System.Reflection;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Xps.Packaging;

namespace DocumentViewerDemo
{
    public partial class Window1 : Window
    {
        public Window1()
        {
            InitializeComponent();

            string documentPath = "DocumentViewerDemo.test.xps";
            Stream stream = Assembly.GetExecutingAssembly().GetManifestResourceStream(documentPath);
            int length = (int)stream.Length;
            MemoryStream ms = new MemoryStream();
            ms.Capacity = (int)length;
            byte[] buffer = new byte[length];
            stream.Read(buffer, 0, length);
            ms.Write(buffer, 0, length);
            Package pkg = Package.Open(ms);
            string strMemoryPackageName = string.Format("memorystream://{0}", documentPath);
            Uri packageUri = new Uri(strMemoryPackageName);
            PackageStore.AddPackage(packageUri, pkg);
            XpsDocument doc = new XpsDocument(pkg, CompressionOption.Maximum, strMemoryPackageName);

            documentViewer.Document = doc.GetFixedDocumentSequence();
        }

        private void setSearchTextButton_Click(object sender, RoutedEventArgs e)
        {
            object toolbar = documentViewer.Template.FindName("PART_FindToolBarHost", documentViewer);

            PropertyInfo contentInfo = toolbar.GetType().GetProperty("Content");
            object findToolbar = contentInfo.GetValue(toolbar, null);

            FieldInfo findTextBoxFieldInfo = findToolbar.GetType().GetField("FindTextBox", BindingFlags.NonPublic | BindingFlags.Instance);
            TextBox findTextBox = (TextBox)findTextBoxFieldInfo.GetValue(findToolbar);

            FieldInfo findNextButtonFieldInfo = findToolbar.GetType().GetField("FindNextButton", BindingFlags.NonPublic | BindingFlags.Instance);
            Button findNextButton = (Button)findNextButtonFieldInfo.GetValue(findToolbar);

            if (findTextBox.Text != "Lorem")
            {
                findTextBox.Text = "Lorem";
            }
            else
            {
                findTextBox.Text = "ipsum";
            }
            
            findNextButton.RaiseEvent(new RoutedEventArgs(Button.ClickEvent));
        }
    }
}